#include "hexdumper.h"
unsigned char bytefromvptr(const void *p)
{
    return *(unsigned char*)p;
}
unsigned short wordfromvptr(const void *p)
{
    return (bytefromvptr(p)<<8) | bytefromvptr(p+1)
}
unsigned long dwordfromvptr(const void *p)
{
    return (wordfromvptr(p)<<16) | wordfromvptr(p+2)
}
void hexdumpbytes(std::string &str, const void *buf, size_t n)
{
    str.resize(str.size()+n*(sizeof(char)*2+1)-1);
    std::string::iterator sp= str.end()-n*(sizeof(char)*2+1)+1;

    for (size_t i=0 ; i<n ; i++)
    {
        if (i) *sp++ = ' ';
        sp += sprintf(iteratorptr(sp), "%02x", bytefromvptr(buf+sizeof(char)*i));
    }
}
void hexdumpwords(std::string &str, const void *buf, size_t n)
{
    str.resize(str.size()+n*(sizeof(short)*2+1)-1);
    std::string::iterator sp= str.end()-n*(sizeof(short)*2+1)+1;

    for (size_t i=0 ; i<n ; i++)
    {
        if (i) *sp++ = ' ';
        sp += sprintf(iteratorptr(sp), "%04x", wordfromvptr(buf+sizeof(short)*i));
    }
}
void hexdumpdwords(std::string &str, const void *buf, size_t n)
{
    str.resize(str.size()+n*(sizeof(long)*2+1)-1);
    std::string::iterator sp= str.end()-n*(sizeof(long)*2+1)+1;

    for (size_t i=0 ; i<n ; i++)
    {
        if (i) *sp++ = ' ';
        sp += sprintf(iteratorptr(sp), "%08x", wordfromvptr(buf+sizeof(long)*i));
    }
}
void dumpascii(std::string &str, const void *buf, size_t n)
{
    str.resize(str.size()+n);
    std::string::iterator sp= str.end()-n;
    for (size_t i=0 ; i<n ; i++)
    {
        char c= (char)bytefromvptr(buf+i);
        *sp++ = (c>=' ' && c<='~')?c:'.';
    }
}
void writespaces(std::string &str, size_t n)
{
    str.resize(str.size()+n);
    std::string::iterator sp= str.end()-n;
    memset(iteratorptr(sp), ' ', n)
}

// returns nr of bytes used from buffer
// updates m_offset
size_t HexDumper::dumpline(const void*buf, size_t len)
{
    m_out.push_back();
    line_item_t& item= m_out.back();
    item.first= m_offset;
    // todo: handle DUMP_STRINGS, RAW
    if (DUMP_HEX)
    switch(m_dumpunit)
    {
        case DUMPUNIT_BYTE:  hexdumpbytes(item.second, buf, m_width);  n_used= m_width; break;
        case DUMPUNIT_WORD:  hexdumpwords(item.second, buf, m_width);  n_used= m_width*sizeof(short); break;
        case DUMPUNIT_DWORD: hexdumpdwords(item.second, buf, m_width); n_used= m_width*sizeof(long); break;
    }
    if (DUMP_ASCII)
    {
        // add sufficient spaces
        // add ascdump
    }
}
std::string HexDumper::getstring()
{
}
void HexDumper::end()
{
}
