/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/leds/batt.cpp,v 1.3 2005/06/12 22:52:53 itsme Exp $
 */
#include  <windows.h>
#include  <pm.h>
#include "debug.h"

// devlist for sp3
// devlist for sp3i,  is lacking: COM1, COM5, DSK1
TCHAR *devices[]= { 
// devs found on all devices
    _T("ACM1:"),  _T("ACM3:"),  _T("ACM9:"),  _T("BAT1:"),  _T("BKL1:"),  _T("BTD0:"),  _T("COM2:"),  _T("COM8:"),  _T("DSK1:"),  _T("IP60:"),  _T("IPD0:"),  _T("NDS0:"),  _T("RIL1:"),  _T("SIM1:"),  _T("SMS1:"),  _T("WAM1:"),  _T("WAV1:"),
// specific sp devs
    _T("WAP1:"),  _T("PER1:"),  _T("RDO1:"),  _T("LOG1:"),  _T("LOG2:"),  _T("COM5:"),  _T("COM1:"),
// specific xda2 devs
    _T("AGW1:"), _T("BAT2:"), _T("BSP2:"), _T("DSK2:"), _T("SIP0:"), _T("SPI1:"), _T("UIO1:"),};
#define NR_DEVS (sizeof(devices)/sizeof(TCHAR*))
// only BKL1 has an actual status.

int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("batt.log");
    while (1) {
        WordVector wv; wv.resize(16);
        DWORD pflags= 0;
        DWORD res= 0;
        do {
            wv.resize(wv.size()*2);
            res= GetSystemPowerState(vectorptr(wv), wv.size(), &pflags);
        } while (res==ERROR_INSUFFICIENT_BUFFER && wv.size()<65536);
        if (res!=ERROR_SUCCESS) {
            error(res, "GetSystemPowerState");
        }

        SYSTEM_POWER_STATUS_EX2 stat2;
        if (!GetSystemPowerStatusEx2(&stat2, sizeof(stat2), false))
            error("GetSystemPowerStatusEx2");
        debug("%5d %5d %5d %5d %5d %5d %5d %5d %5d %5d %5d %5d %5d  %5d %5d %5d %5d %5d %5d %5d %5d %5d %5d\n",
                GetTickCount(),                         //
                stat2.BatteryFlag,                      //
                stat2.BatteryLifePercent,               //
                stat2.BatteryVoltage,                   //  
                stat2.BatteryCurrent,                   //  
                stat2.BatteryAverageCurrent,            //  
                stat2.BatteryTemperature,               //  
                stat2.ACLineStatus,                     //  0x00
                stat2.Reserved1,                        //  0x00
                stat2.BatteryLifeTime,                  //  -1
                stat2.BatteryFullLifeTime,              //  -1
                stat2.Reserved2,                        //  0x00
                stat2.BackupBatteryFlag,                //  0x01
                stat2.BackupBatteryLifePercent,         //  255
                stat2.Reserved3,                        //  0x00
                stat2.BackupBatteryLifeTime,            //  -1
                stat2.BackupBatteryFullLifeTime,        //  -1
                stat2.BatteryAverageInterval,           //  0
                stat2.BatterymAHourConsumed,            //  0
                stat2.BackupBatteryVoltage,             //  0
                stat2.BatteryChemistry,                 //  5
                pflags,                                 //  00010000
                vectorptr(wv));                         //  on
                                                            
        debug("devices: ");
        for (int i=0 ; i<NR_DEVS ; i++) {
            CEDEVICE_POWER_STATE state= PwrDeviceUnspecified;
            GetDevicePower(devices[i], POWER_NAME|POWER_FORCE, &state);
            if (state!=PwrDeviceUnspecified)
                debug(" %ls=%d", devices[i], state);
        }
        debug("\n");
        Sleep(60000);
    }

    return 0;
}

