/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/leds/tstitsutils.cpp,v 1.3 2005/06/12 22:52:37 itsme Exp $
 */
#include  <windows.h>
#include  <Pwinuser.h>
#include "debug.h"
#include "stringutils.h"

typedef HRESULT (STDAPICALLTYPE *rapifn)(
        DWORD cbInput, void *pbInput,
        DWORD *pcbOutput, void **ppbOutput,
        void *pStream);

bool tstapiver(HINSTANCE hLib)
{
    // test api version
    rapifn getver= (rapifn )GetProcAddress(hLib, L"ITGetVersion");
    if (getver==NULL) {
        error("GetProcAddress(ITGetVersion)");
        return false;
    }
    debug("ITGetVersion= %08lx\n", getver);

    DWORD dwSize;
    BYTE *buf;
    HRESULT res= getver(0, NULL, &dwSize, (void**)&buf, NULL);

    debug("itsutils api version=%d\n", res);

    return true;
}
bool tstgetctx(HINSTANCE hLib)
{
    // test get context
    rapifn getctx= (rapifn )GetProcAddress(hLib, L"ITGetContext");
    if (getctx==NULL) {
        error("GetProcAddress(ITGetContext)");
        return false;
    }
    debug("ITGetContext= %08lx\n", getctx);

    DWORD dwSize;
    BYTE *buf;
    HRESULT res= getctx(0, NULL, &dwSize, (void**)&buf, NULL);
    if (dwSize && buf) {
        debug("answer: %hs\n", hexdump(buf, dwSize).c_str());

        LocalFree(buf);
    }

    return true;
}
bool tstgetphandle(HINSTANCE hLib)
{
    // test get process handle
    rapifn getph= (rapifn )GetProcAddress(hLib, L"ITGetProcessHandle");
    if (getph==NULL) {
        error("GetProcAddress(ITGetProcessHandle)");
        return false;
    }
    debug("ITGetProcessHandle= %08lx\n", getph);

    WCHAR *szProcname= L"device.exe";
    DWORD dwSize;
    BYTE *buf;
    HRESULT res= getph((wcslen(szProcname)+1)*sizeof(WCHAR), (BYTE*)szProcname, &dwSize, (void**)&buf, NULL);
    if (dwSize && buf) {
        debug("answer: %hs\n", hexdump(buf, dwSize).c_str());

        LocalFree(buf);
    }

    return true;
}
bool tstgetplist(HINSTANCE hLib)
{
    // test get context
    rapifn getplist= (rapifn )GetProcAddress(hLib, L"ITGetProcessList");
    if (getplist==NULL) {
        error("GetProcAddress(ITGetProcessList)");
        return false;
    }
    debug("ITGetProcessList= %08lx\n", getplist);

    bool bParam= false;
    DWORD dwSize;
    BYTE *buf;
    HRESULT res= getplist(sizeof(bool), (BYTE*)&bParam, &dwSize, (void**)&buf, NULL);
    if (dwSize && buf) {
        if (dwSize>64) {
            debug("truncating %d to 64 bytes\n", dwSize);
            dwSize= 64;
        }
        debug("answer: %hs\n", hexdump(buf, dwSize).c_str());

        LocalFree(buf);
    }

    return true;
}
int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("tstits.log");

    HINSTANCE hLib= LoadLibrary(L"itsutils.dll");
    if (hLib==NULL || hLib==INVALID_HANDLE_VALUE) {
        error("LoadLibrary");
        return 1;
    }
    debug("hLib= %08lx\n", hLib);

    tstapiver(hLib);
    tstgetctx(hLib);
    tstgetphandle(hLib);
    tstgetplist(hLib);

    FreeLibrary(hLib);

    return 0;
}
