/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/src/pkill.cpp,v 1.12 2005/06/12 23:34:01 itsme Exp $
 */
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <rapi.h>

#include "debug.h"
#include "args.h"
#include "ptrutils.h"

#include "ItsUtils.h"
#include "dllversion.h"

// todo: kill by handle does not seem to work.
void ITTerminateProcess(DWORD dwHandle, char *szProcessName);

int main( int argc, char *argv[])
{
    DebugStdOut();

    if (argc==1)
    {
        printf("Usage: pkill [ {-h HANDLE } | { processname } ]...\n");
        return 1;
    }

    CheckITSDll();


    for (int i=1 ; i<argc ; i++) {
        if (strncmp(argv[i], "-h", 2)==0) {
            DWORD dwHandle;
            if (HANDLEULOPTION(dwHandle, DWORD))
                ITTerminateProcess(dwHandle, NULL);
        }
        else {
            ITTerminateProcess(0, argv[i]);
        }
    }

    CeRapiUninit();

    return 0;
}

void ITTerminateProcess(DWORD dwHandle, char *szProcessName)
{
    TerminateProcessParams*inbuf=NULL;
    DWORD insize= szProcessName ? PTR_DIFF(inbuf, inbuf->wszProcessName+strlen(szProcessName)+1)
            : PTR_DIFF(inbuf, inbuf->wszProcessName+1);
    inbuf= (TerminateProcessParams*)LocalAlloc(LPTR, insize);
    DWORD outsize=0;

    inbuf->dwHandle= dwHandle;
    if (szProcessName) {
        _snwprintf(inbuf->wszProcessName, strlen(szProcessName), L"%hs", szProcessName);
        inbuf->wszProcessName[strlen(szProcessName)]= 0;
    }
    else {
        inbuf->wszProcessName[0]= 0;
    }

    HRESULT res= CeRapiInvoke(L"\\Windows\\ItsUtils.dll", L"ITTerminateProcess",
            insize, (BYTE*)inbuf,
            &outsize, NULL, NULL, 0);
    if (res)
        error(res, "killing %08lx | %s", dwHandle, szProcessName?szProcessName:"-");
    else
        debug("%08lx | %s killed\n", dwHandle, szProcessName?szProcessName:"-");
}
