/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/src/prun.cpp,v 1.7 2005/03/25 14:44:54 itsme Exp $
 */
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <rapi.h>

#include <string>
#include "stringutils.h"
#include "debug.h"

// todo:
//    add '-w'  option to wait ( a maximum ) time for the execution to finish
//    ... implement this by calling itsutils.dll ITRunProcess
//    ...    which should WaitForSingleObject on the process handle
int main( int argc, char *argv[])
{
    DebugStdOut();

    if (FAILED(CeRapiInit()))
    {
        error("Failed\n");
        return 1;
    }

    if (argc==1)
    {
        printf("Usage: prun exepath [arguments]\n");
        return 1;
    }

    std::string cmd= argv[1];

    std::string cmdline;

    for (int i=2 ; i<argc ; i++)
    {
        if (i>2)
            cmdline += ' ';
        cmdline += argv[i];
    }

    PROCESS_INFORMATION pi;
    if (!CeCreateProcess( ToWString(cmd).c_str(), ToWString(cmdline).c_str(),
            NULL, NULL, FALSE, 0, NULL, NULL, NULL,
            &pi))
    {
        ceerror("CreateProcess failed with Errorcode = %ld\n", CeGetLastError());
    }
    else
    {
        CeCloseHandle( pi.hProcess);
        CeCloseHandle( pi.hThread);
    }

    CeRapiUninit();

    return 0;
}

