/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/src/psynctime.cpp,v 1.4 2005/02/23 14:11:40 itsme Exp $
 *
 * to start this util automatically each time a device is cradled:
 *
 * [HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows CE Services\AutoStartOnConnect]
 * "psynctime"="c:\\path-to\\psynctime.exe"
 * 
 */
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <rapi.h>

#include "debug.h"

#include "ItsUtils.h"
#include "dllversion.h"

void ITSetSystemTime(SYSTEMTIME *time, TIME_ZONE_INFORMATION *tzinfo);

int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugStdOut();

	SYSTEMTIME time;
    TIME_ZONE_INFORMATION tzinfo;

    GetSystemTime(&time);
    GetTimeZoneInformation(&tzinfo);

    CheckITSDll();

    ITSetSystemTime(&time, &tzinfo);

    CeRapiUninit();

    // work around activesync bug, where it always removes the
    // focus from the current window
    HWND hFgnd= GetForegroundWindow();
    //SetForegroundWindow(hFgnd);
    ShowWindowAsync(hFgnd, SW_SHOW);
    return 0;
}

void ITSetSystemTime(SYSTEMTIME *time, TIME_ZONE_INFORMATION *tzinfo)
{
    DWORD insize= sizeof(SetSystemTimeParams);
    SetSystemTimeParams inbuf;
    DWORD outsize=0;

    memcpy(&inbuf.time, time, sizeof(SYSTEMTIME));
    memcpy(&inbuf.tzinfo, tzinfo, sizeof(TIME_ZONE_INFORMATION));

    HRESULT res= CeRapiInvoke(L"\\Windows\\ItsUtils.dll", L"ITSetSystemTime",
            insize, (BYTE*)&inbuf,
            &outsize, NULL, NULL, 0);
}
